diff -r 1b9173c89d92 erts/emulator/beam/bif.c
--- a/erts/emulator/beam/bif.c	Sun Dec 11 04:15:55 2005
+++ b/erts/emulator/beam/bif.c	Mon Dec 12 17:00:57 2005
@@ -3823,3 +3823,42 @@
     }
     BIF_RET(ret);
 }
+
+/**********************************************************************/
+
+/* find a series of characters in a binary */
+
+BIF_RETTYPE strstr_binary_2(BIF_ALIST_2)
+{
+    Eterm big = BIF_ARG_1;
+    Eterm little = BIF_ARG_2;
+
+    if (is_binary(big) && is_binary(little)) {
+
+        char* big_ptr;
+        int big_len = binary_size(big);
+        GET_BINARY_BYTES(big, big_ptr);
+
+        char* little_ptr;
+        int little_len = binary_size(little);
+        GET_BINARY_BYTES(little, little_ptr);
+
+        char* cur;
+        char* max_big = (big_ptr + big_len) - little_len ;
+        char  first_little = *little_ptr;
+        int   index = -1;
+
+        for (cur = big_ptr; cur <= max_big; cur++) {
+            if (*cur == first_little && memcmp(cur, little_ptr, little_len) == 0) {
+                index = (int)cur - (int)big_ptr;
+                break;
+            }
+        }
+
+        BIF_RET(make_small(index));
+    } else {
+	BIF_ERROR(BIF_P, BADARG);
+    }
+}
+
+
diff -r 1b9173c89d92 erts/emulator/beam/bif.tab
--- a/erts/emulator/beam/bif.tab	Sun Dec 11 04:15:55 2005
+++ b/erts/emulator/beam/bif.tab	Mon Dec 12 17:00:57 2005
@@ -656,3 +656,8 @@
 #
 #bif erlang:concat_binary/1
 #bif erlang:info/1
+
+bif erlang:strstr_binary/2
+
+
+
